Smart Proxy - Refactor #10324

Performance issues with Foreman Proxy Puppet CA plugin and large CA inventories
04/29/2015 04:03 PM - Jon McKenzie

Status: Closed
Priority: Normal
Assignee: Jon McKenzie
Category: Puppet
Target version: 1.8.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/smart-pro
xy/pull/283
Description

Proxy::PuppetCa.list (https://github.com/theforeman/smart-proxy/blob/develop/modules/puppetca/puppetca_main.rb#L69) takes an
extremely long period of time to complete when the CA inventory list is relatively large and there have been a relatively large number
of revoked certificates.

The source of this issue is in Proxy::PuppetCa#ca_inventory, which performs a very slow O(n*2) operation to build up a hash of
certificate data and whether each certificate has been revoked. In particular, the Proxy::PuppetCa#ca_inventory iterates through
every certificate in the inventory and then looks up that certificate's serial in the array returned by Proxy::PuppetCa#revoked_serials.
When both the inventory and the list of revoked clients is large, this operation is extremely slow.

The downstream effect of this issue is that trying to interact with the Puppet CA via Foreman simply times out (the read_timeout on
the RestClient request is only 60 seconds, the Proxy::PuppetCa.list operation in our environment takes approximately 80s).

Perhaps a way to make this faster this would be to just return a valueless Hash from Proxy::PuppetCa#revoked_serials so that the
serial lookup is ~O(1).

Just to give you some numbers to work with, we have approximately 10900 certificates in our inventory and about 8900 of them are
revoked.

Associated revisions

Revision 0a83088c - 05/05/2015 08:56 AM - Jon McKenzie

Fixes #10324 - Improves certificate serial lookup in Puppet CA module

Use a set instead of an array to improve lookup performance when the number of revoked certificates is large.

History

#1 - 04/30/2015 03:34 AM - Dominic Cleal
- Category set to Puppet

#2 - 05/04/2015 08:52 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/283 added
- Pull request deleted ()

#3 - 05/05/2015 09:01 AM - Jon McKenzie
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 0a83088cf447fc4f67d1c68fd375adea7fb0a709.

#4 - 05/05/2015 09:06 AM - Dominic Cleal
https://github.com/theforeman/smart-proxy/blob/develop/modules/puppetca/puppetca_main.rb#L69
https://projects.theforeman.org/projects/smart-proxy/repository/7/revisions/0a83088cf447fc4f67d1c68fd375adea7fb0a709

- Assignee set to Jon McKenzie

- translation missing: en.field_release set to 50
